﻿Type=Activity
Version=1.20
FullScreen=True
IncludeTitle=False
@EndOfDesignText@
'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim CurrentArtist As String
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim ArtistORSong As Boolean ' True = Artist List: False = Songs of that Artist
	
	Dim TabHost1 As TabHost
	Dim lvSongs As ListView
	Dim lvArtist As ListView
	Dim lvFavorites As ListView
	
	Dim txtSearch As EditText
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("tabListStart")
	
	tabHost1.AddTab("Artist", "TabArtist")
	TabHost1.AddTab("Songs", "TabSongs")
	TabHost1.AddTab("Favorites", "TabFavorites")
	
	Activity.AddMenuItem("Search", "SearchList")
	Activity.AddMenuItem("Help", "HelpPanel")
	Activity.AddMenuItem("About", "AboutApp")
	Activity.AddMenuItem("Exit", "ExitApp")
	If main.SQL1.IsInitialized = False Then
		main.SQL1.Initialize(File.DirDefaultExternal, "SongBook.db", False)
	End If
		
	UpDateArtist
	'UpDateSongs
	'lvSongs.FastScrollEnabled = False
'	lvSongs.TwoLinesAndBitmap.ImageView.Left = lvSongs.Width - 100
'	lvSongs.TwoLinesAndBitmap.Label.Left = 0
'	lvSongs.TwoLinesAndBitmap.SecondLabel.Left = 0
'	lvSongs.TwoLinesAndBitmap.Label.Width = lvSongs.Width - 100
'	lvSongs.TwoLinesAndBitmap.SecondLabel.Width = lvSongs.Width - 100
End Sub

Sub Activity_Resume
	If main.SQL1.IsInitialized = False Then
		main.SQL1.Initialize(File.DirDefaultExternal, "SongBook.db", False)
	End If
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	
End Sub
Sub UpdateArtist
	CurrentArtist = ""
	lvArtist.Clear
	Dim Cursor1 As Cursor
	Cursor1 = main.SQL1.ExecQuery("SELECT DISTINCT artist FROM main;")
	For i = 0 To Cursor1.RowCount - 1
		Cursor1.Position = i
		lvArtist.AddSingleLine(Cursor1.GetString("artist"))
	Next 	
	lvArtist.Invalidate
	Cursor1.Close
End Sub
Sub UpdateSongs
	lvSongs.Clear
	Dim Cursor1 As Cursor
	Dim Bitmap1 As Bitmap
	Dim BitmapEmpty As Bitmap
	Bitmap1.Initialize(File.DirAssets, "Star2.png")
	BitmapEmpty.Initialize(File.DirAssets, "Empty100x100.png")
	'This moves the Bitmap to the Right side of the screen
	lvSongs.TwoLinesAndBitmap.ImageView.Left = lvSongs.Width - (Bitmap1.Width / 1.5)
	lvSongs.TwoLinesAndBitmap.Label.Left = 0
	lvSongs.TwoLinesAndBitmap.SecondLabel.Left = 0
	'lvSongs.TwoLinesAndBitmap.Label.Width = lvSongs.Width - Bitmap1.Width
	'lvSongs.TwoLinesAndBitmap.SecondLabel.Width = lvSongs.Width - Bitmap1.Width
	If CurrentArtist <> "" Then
		Cursor1 = main.SQL1.ExecQuery("SELECT DISTINCT * FROM main WHERE artist = " & QUOTE & CurrentArtist & QUOTE & " ORDER BY title;")
		For i = 0 To Cursor1.RowCount - 1
			Cursor1.Position = i
			If Cursor1.GetInt("fav") = 0 Then
				lvSongs.AddTwoLinesAndBitmap(Cursor1.GetString("title"), cursor1.GetString("artist"), BitmapEmpty)
			Else
				lvSongs.AddTwoLinesAndBitmap(Cursor1.GetString("title"), cursor1.GetString("artist"), Bitmap1)
			End If
		Next		
	Else
		Cursor1 = main.SQL1.ExecQuery("SELECT * FROM main ORDER BY title;")
		For i = 0 To Cursor1.RowCount - 1
			Cursor1.Position = i
			If Cursor1.GetInt("fav") = 0 Then
				lvSongs.AddTwoLinesAndBitmap(Cursor1.GetString("title"), cursor1.GetString("artist"), BitmapEmpty)
			Else
				lvSongs.AddTwoLinesAndBitmap(Cursor1.GetString("title"), cursor1.GetString("artist"), Bitmap1)
			End If
		Next
	End If
	Cursor1.Close
	lvSongs.Invalidate
End Sub

Sub UpdateFavorites
	lvFavorites.Clear
	Dim Cursor1 As Cursor
	Dim Bitmap1 As Bitmap
	Bitmap1.Initialize(File.DirAssets, "Empty100x100.png")
	lvFavorites.TwoLinesAndBitmap.ImageView.Left = lvFavorites.Width - (Bitmap1.Width / 1.2)
	lvFavorites.TwoLinesAndBitmap.Label.Left = 0
	lvFavorites.TwoLinesAndBitmap.SecondLabel.Left = 0
	Cursor1 = main.SQL1.ExecQuery("SELECT DISTINCT * FROM main WHERE fav = '1' ORDER BY title;")
	For i = 0 To Cursor1.RowCount - 1
		Cursor1.Position = i
		lvFavorites.AddTwoLinesAndBitmap(Cursor1.GetString("title"), Cursor1.GetString("artist"), BitMap1)
	Next		
	Cursor1.Close
	lvFavorites.Invalidate
End Sub
Sub lvArtist_ItemClick (Position As Int, Value As Object)
	CurrentArtist = Value
	UpdateSongs
	TabHost1.CurrentTab = (TabHost1.CurrentTab + 1) Mod TabHost1.TabCount
End Sub
Sub lvArtist_ItemLongClick (Position As Int, Value As Object)
	
End Sub
Sub lvSongs_ItemClick (Position As Int, Value As Object)
	Dim String1 As String
	Dim Cursor1 As Cursor
	String1 = Value
	If String1.StartsWith("**") Then
		String1 = String1.Replace("**", "")
	End If
	Cursor1 = main.SQL1.ExecQuery("Select * FROM main WHERE title = " & QUOTE & String1 & QUOTE & ";")
	If Cursor1.RowCount > 0 Then
		Cursor1.Position = 0
		Msgbox(Cursor1.GetString("artist") & CRLF & Cursor1.GetString("title"), "Song")
	End If	
	Cursor1.Close
End Sub
Sub TabHost1_TabChanged
	
	Select TabHost1.CurrentTab
		Case 0
			CurrentArtist = "" 'Title Listview, Clear currentArtist
			UpdateArtist
		Case 1
			If CurrentArtist = "" Then ' Song Listview, If a Artist is selected we will display that in lvArtist click, otherwise show all songs
				UpdateSongs
			End If
		Case 2
			UpdateFavorites ' Show Favorites on this list.
		Case Else
	End Select
	
	
	
End Sub
Sub lvSongs_ItemLongClick (Position As Int, Value As Object)
	'Msgbox(Value, "Song Long")
	
	Dim Cursor1 As Cursor
	If CurrentArtist = "" Then
		Cursor1 = main.SQL1.ExecQuery("SELECT * FROM main WHERE title = " & QUOTE & Value & QUOTE & ";")
		If Cursor1.RowCount > 1 Then
			Dim List1 As List
			List1.Initialize
			For i = 0 To Cursor1.RowCount - 1
				Cursor1.Position = i
				List1.Add(Cursor1.GetString("artist"))
			Next
			i = InputList(List1, "Select Artist", 0)
			If i > -1 Then
				Cursor1 = main.SQL1.ExecQuery("SELECT * FROM main WHERE artist = " & QUOTE & List1.Get(i) & QUOTE & " AND title = " & QUOTE & Value & QUOTE & ";")
			End If
		End If	
	Else
		Cursor1 = main.SQL1.ExecQuery("SELECT * FROM main WHERE artist = " & QUOTE & CurrentArtist & QUOTE & " AND title = " & QUOTE & Value & QUOTE & ";")
	End If
		Cursor1.Position = 0
	If Cursor1.GetInt("fav") = 0 Then
		main.SQL1.ExecNonQuery("UPDATE main SET fav='1' WHERE title = " & QUOTE & Value & QUOTE & " AND artist = " & QUOTE & Cursor1.GetString("artist") & QUOTE & ";")
	Else
		main.SQL1.ExecNonQuery("UPDATE main SET fav='0' WHERE title = " & QUOTE & Value & QUOTE & " AND artist = " & QUOTE & Cursor1.GetString("artist") & QUOTE & ";")
	End If
	Cursor1.Close
	UpdateSongs
End Sub
Sub lvFavorites_ItemLongClick (Position As Int, Value As Object)
	Dim Cursor1 As Cursor
	Cursor1 = main.SQL1.ExecQuery("Select * FROM main WHERE title = " & QUOTE & Value & QUOTE & " AND fav = 1;")
	If Cursor1.RowCount > 1 Then
		Dim List1 As List
		List1.Initialize
		For i = 0 To Cursor1.RowCount - 1
			cursor1.Position = i
			List1.Add(Cursor1.GetString("artist"))
		Next
		i = InputList(List1, "Select Artist", 0)
		Main.SQL1.ExecNonQuery("UPDATE main SET fav = 0 WHERE title =  " & QUOTE & Value & QUOTE & " AND artist = " & QUOTE & List1.Get(i) & QUOTE & ";")
	Else
		Main.SQL1.ExecNonQuery("UPDATE main SET fav = 0 WHERE title =  " & QUOTE & Value & QUOTE & ";")
	End If
	Cursor1.Close
	UpdateFavorites
End Sub
Sub TabHost1_Click
	'Msgbox(TabHost1.CurrentTab, "CurrentTab")
End Sub
Sub TabHost1_LongClick
	'Msgbox(TabHost1.CurrentTab, "CurrentTab")
End Sub
Sub ExitApp_Click 'Menu Item
	Activity.Finish
End Sub
Sub AboutApp_Click 'Menu Item
	StartActivity(About)
End Sub
Sub SearchList_Click 'Menu Item
	txtSearch.Text = ""
	txtSearch.Visible = True
	txtsearch.BringToFront
	txtsearch.RequestFocus
End Sub

Sub txtSearch_TextChanged (Old As String, New As String)
	'Search Function, every time a new letter is put in the text box we will search the Database and Display the matching items
	
	Dim Cursor1 As Cursor
	Select TabHost1.CurrentTab
		Case 0
			lvArtist.Clear 'SQL1.ExecNonQuery("CREATE TABLE main (artist TEXT, title TEXT, fav INTEGER)")
			Cursor1 = main.SQL1.ExecQuery("SELECT DISTINCT artist FROM main WHERE artist LIKE '%" & New & "%'  ORDER BY 'artist';")
			For i = 0 To Cursor1.RowCount - 1
				Cursor1.Position = i
				lvArtist.AddSingleLine(Cursor1.GetString("artist"))
			Next
			lvArtist.Invalidate
		Case 1
			lvSongs.Clear 'SQL1.ExecNonQuery("CREATE TABLE main (artist TEXT, title TEXT, fav INTEGER)")
			If CurrentArtist = "" Then
				Cursor1 = main.SQL1.ExecQuery("SELECT DISTINCT * FROM main WHERE title LIKE '%" & New & "%' ORDER BY title;")
			Else
				Cursor1 = main.SQL1.ExecQuery("SELECT DISTINCT * FROM main WHERE artist = " & QUOTE & CurrentArtist & QUOTE & " AND title LIKE '%" & New & "%' ORDER BY title;")
			End If
			For i = 0 To Cursor1.RowCount - 1
				Cursor1.Position = i
				If Cursor1.GetInt("fav") = 0 Then
					lvSongs.AddTwoLines(Cursor1.GetString("title"), cursor1.GetString("artist"))
				Else
					lvSongs.AddTwoLines("**" & Cursor1.GetString("title") & "**", cursor1.GetString("artist"))
				End If
			Next
			lvSongs.Invalidate
		Case 2
			lvFavorites.Clear 'SQL1.ExecNonQuery("CREATE TABLE main (artist TEXT, title TEXT, fav INTEGER)")
			Cursor1 = main.SQL1.ExecQuery("SELECT DISTINCT * FROM main WHERE fav = '1' AND title LIKE '%" & New & "%' ORDER BY title;")
			For i = 0 To Cursor1.RowCount - 1
				Cursor1.Position = i
				If Cursor1.GetInt("fav") = 0 Then
					lvFavorites.AddTwoLines(Cursor1.GetString("title"), cursor1.GetString("artist"))
				Else
					lvFavorites.AddTwoLines("**" & Cursor1.GetString("title") & "**", cursor1.GetString("artist"))
				End If
			Next
			lvFavorites.Invalidate
	
		Case Else
			
	End Select
	Cursor1.Close
End Sub
Sub txtSearch_EnterPressed
	txtSearch.Visible = False
End Sub
Sub Activity_KeyPress (KeyCode As Int) As Boolean
	If KeyCode = KeyCodes.KEYCODE_BACK AND txtSearch.Visible = True Then
		txtSearch.Visible = False
		Return True
	End If
	If KeyCode = KeyCodes.KEYCODE_BACK AND TabHost1.CurrentTab = 1 Then
		TabHost1.CurrentTab = 0
		Return True
	Else
		Return False
	End If
End Sub